# -*- coding: utf-8 -*-

import sys
from PyQt5 import QtWidgets, QtCore, QtGui
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *
from PyQt5.QtCore import *
from MyQR import myqr
import shutil #这个库复制文件比较省事


class coolqr(QWidget):
    def __init__(self):
        super(coolqr, self).__init__()

        self.resize(340, 520) #窗口大小
        self.setWindowTitle("极酷二维码")

        self.qr = QLabel(self) # 在一个Label控件中显示二维码
        #self.qr.setText("极酷二维码")
        self.qr.setPixmap(QtGui.QPixmap("MyQR.gif").scaled(300,300)) # 二维码初始显示设置
        self.qr.setFixedSize(300, 300)
        self.qr.move(20, 20)
        # self.qr.setStyleSheet("QLabel{background:white;color:rgb(300,300,300,120);font-size:10px;font-weight:bold;font-family:宋体;}")

        self.label1 = QLabel(self) 
        self.label1.setText("标题：")
        self.label1.move(20, 340)

        self.label2 = QLabel(self) 
        self.label2.setText("内容：")
        self.label2.move(20, 370)

        self.label3 = QLabel(self) 
        self.label3.setText("背景：")
        self.label3.move(20, 400)

        self.label2 = QLabel(self) 
        self.label2.setText("颜色：")
        self.label2.move(20, 430)

        self.t_name = QLineEdit(self)
        self.t_name.move(60,335)
        self.t_name.resize(240,20) 
        self.t_name.setText("MyQrCode")

        self.t_content = QLineEdit(self)
        self.t_content.move(60,365)
        self.t_content.resize(240,20)
        self.t_content.setPlaceholderText('请在此输入二维码识别的内容...')
        self.t_content.setFocus() #使内容框获得焦点

        self.btn_img = QPushButton(self)
        self.btn_img.setText(" 选择背景图片... ")
        self.btn_img.move(60, 395)
        self.btn_img.clicked.connect(self.openimage)

        self.rb1 = QRadioButton('彩色',self)
        self.rb1.setChecked(True)
        self.rb2 = QRadioButton('黑白',self)
        self.rb1.move(60,430)
        self.rb2.move(120,430)
        self.bg = QButtonGroup(self)
        self.bg.addButton(self.rb1, 1)
        self.bg.addButton(self.rb2, 2)
        self.bg.buttonClicked.connect(self.rbclicked)
        
        
        self.btn_generate = QPushButton(self)
        self.btn_generate.setText("生成")
        self.btn_generate.move(70, 460)
        self.btn_generate.clicked.connect(self.generate)

        self.btn_save = QPushButton(self)
        self.btn_save.setText("保存")
        self.btn_save.move(200, 460)
        self.btn_save.clicked.connect(self.saveimg)

        self.rb = True
        self.imgname='0.png'

    def rbclicked(self):
        if self.rb1.isChecked() == True:
            self.rb=True
        else:
            self.rb=False

    def openimage(self):
        imgName, imgType = QFileDialog.getOpenFileName(self, "打开图片", "", "*.jpg;;*.png;;*.gif;;All Files(*)")
        jpg = QtGui.QPixmap(imgName).scaled(self.qr.width(), self.qr.height())
        self.qr.setPixmap(jpg)
        self.imgname=imgName

    def generate(self):
        t=self.t_content.text()
        p=self.imgname
        c=self.rb
        s=self.t_name.text()+'.gif'

        if t=='':
            t='CoolQrCode'

        myqr.run(words=t,
                 picture=p,
                 colorized=c,
                 save_name=s,
                 )

        self.qr.setPixmap(QtGui.QPixmap(s).scaled(300,300))
        
    def saveimg(self):
        filename = QFileDialog.getSaveFileName(self, "保存二维码", "MyQRCode", "GIF文件 (*.gif)")[0]
        s = self.t_name.text() + '.gif'
        shutil.copy(s, filename)


if __name__ == "__main__":
    app = QtWidgets.QApplication(sys.argv)
    my = coolqr()
    my.show()
    sys.exit(app.exec_())
